﻿using Microsoft.VisualStudio.TestTools.WebTesting;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benday.WebLoadTest.Utilities
{
    [DisplayName("Extract Response Filename")]
    [Description("Extracts the filename portion of the URL of the response.")]
    public class ExtractResponseUrlFilename : ExtractionRule
    {
        public override void Extract(
            object sender, 
            Microsoft.VisualStudio.TestTools.WebTesting.ExtractionEventArgs e)
        {
            var responseUri = e.Response.ResponseUri;

            var responsePath = responseUri.GetLeftPart(UriPartial.Path);

            var responsePathAsUri = new Uri(responsePath);

            var filename = responsePathAsUri.Segments.LastOrDefault();

            e.WebTest.Context.Add(ContextParameterName, filename);

            e.Success = true;
        }
    }
}
